//-----------------------------------------------------------------------------
// name: msg_box()
// desc: ...
//-----------------------------------------------------------------------------
void msg_box( const char * title, const char * msg )
{    
    
#ifdef __PLATFORM_WIN32__
    MessageBox( NULL, msg, title, MB_OK | MB_TASKMODAL );
#elif defined( __MACOSX_CORE__ )
    if( AudicleWindow::our_fullscreen )
    {
        glutReshapeWindow( AudicleWindow::main()->m_w, AudicleWindow::main()->m_h );
        glutPostRedisplay();
        AudicleWindow::our_fullscreen = FALSE;
        return;
    }

    // from http://www.gamedev.net/reference/articles/article2281.asp
    Str255 strTitle;
    Str255 strMessage;
    CopyCStringToPascal( title, strTitle );
    CopyCStringToPascal( msg, strMessage );
    StandardAlert( kAlertNoteAlert, strTitle, strMessage, NULL, 0 );
#else    
    if( g_ok ) return;
    g_ok = TRUE;
    
    GtkWidget *dialog, *label;

    dialog = gtk_dialog_new_with_buttons( title, 
                                          NULL,
                                          GTK_DIALOG_DESTROY_WITH_PARENT,
                                          GTK_STOCK_OK,
                                          GTK_RESPONSE_NONE,
                                          NULL );

    label = gtk_label_new( msg );
    gtk_label_set_selectable( GTK_LABEL( label ), TRUE );

    gtk_container_add( GTK_CONTAINER( GTK_DIALOG( dialog )->vbox ), label );
    gtk_widget_show( label );

    g_signal_connect_swapped( dialog, "response", G_CALLBACK( cb_ok ), NULL );
    g_signal_connect_swapped( dialog, "response", G_CALLBACK( gtk_widget_destroy ), (GtkWidget *)dialog );
    gtk_window_set_position( (GtkWindow *)dialog, GTK_WIN_POS_CENTER );
    gtk_widget_show_all( dialog );
    gtk_main();
    
    // wait
    while( g_ok )
        usleep( 30000 );
        
    // gtk_widget_hide( dialog );
    // gtk_widget_destroy( dialog ); // why is this commented out? shouldn't we be destroying this and label too? like:
	gtk_widget_destroy( dialog );
	gtk_widget_destroy( label );

#endif
}
