////////////////////////////////////////////////////////////////////////////
// File Name:   ui_element.h
// Description: Base class for UI elements
// Author:      Roy Fejgin
// Date:        Autumn 2009
////////////////////////////////////////////////////////////////////////////
#ifndef __UI_ELEMENT__
#define __UI_ELEMENT__

//#include "audio_engine.h"
#include "ui_util.h"


class UI_Element
{
public:

  // Constructor
  UI_Element(float xMin, float xMax, float yMin, float yMax,
    bool isActive):        
        m_xMin(xMin),
        m_xMax(xMax),
        m_yMin(yMin),
        m_yMax(yMax),
        m_isActive(isActive) {
  }

  ~UI_Element() {};

  // Draw self
  virtual void draw() { return; };
  
  // Mouse
  virtual void mouseDown(point p ) { return; };
  virtual void mouseUp(point p ) { return; };
  virtual void mouseMotion(point p) { return; };

  // Return true if the given point is inside this element 
  virtual inline bool intersect(point p) {
    return ((p.x<=m_xMax) && (p.x >= m_xMin) &&
            (p.y<=m_yMax) && (p.y >= m_yMin));
  }

  void setActive(bool val) { m_isActive = val; };
  bool isActive() { return m_isActive; };

protected:
  float m_xMin;
  float m_xMax;
  float m_yMin;
  float m_yMax;
  bool m_isActive;
};

#endif //__UI_ELEMENT__