////////////////////////////////////////////////////////////////////////////
// File Name:   ui_util.cpp
// Description: GUI related utilities
// Author:      Roy Fejgin
// Date:        Autumn 2009
////////////////////////////////////////////////////////////////////////////
#include "Common.h"
#include "ui_util.h"
#include "math.h"

/*********************************************************************************
 Functions
**********************************************************************************/

void switchToOrtho() {
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluOrtho2D(-2,2,-2,2);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();
}

void switchToPerspective()
{
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
}

point getPos(int x, int y)
{
  GLint view[4];
  GLdouble model[16];
  GLdouble proj[16];

  GLdouble winX = x, winY = y, winZ = 0.0;
  GLdouble xPos, yPos, zPos;

  glGetDoublev( GL_MODELVIEW_MATRIX, model );
  glGetDoublev( GL_PROJECTION_MATRIX, proj);
  glGetIntegerv( GL_VIEWPORT, view );
  winY = (float)view[3] - (float)y;

  gluUnProject(	winX, winY, winZ, 
    model, proj, view,
    &xPos, &yPos, &zPos);

  point p;
  p.x = xPos;
  p.y = yPos;
  return p;
}


void displayString(float x, float y, char* string)
{
  char* pChar = string;
  glRasterPos2f(x,y);

  while(*pChar) {
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18 , *pChar);
    pChar++;
  }
}

float randFloat(float a, float b)
{
  return ((b-a)*((float)rand()/RAND_MAX))+a;
}
