////////////////////////////////////////////////////////////////////////////
// File Name:   ui_util.h
// Description: GUI related Utility function
// Author:      Roy Fejgin
// Date:        Autumn 2009
////////////////////////////////////////////////////////////////////////////
#ifndef __UI_UTIL__
#define __UI_UTIL__

#include "RtAudio.h"

//#include "audio_engine.h"
#ifdef __MACOSX_CORE__
// note: for mac only
#include <GLUT/glut.h>
#else
#include <GL/gl.h>
#include <GL/glu.h>
#ifdef WIN32
#include <glut.h>
#else
#include <GL/glut.h>
#endif 
#endif


#include "Common.h"

using namespace std;                

/********************************************************************************* 
 Types and Macros
**********************************************************************************/
class Color {
public:
  Color(float r, float g, float b) :
    m_r(r),
    m_g(g),
    m_b(b) {
  }
    Color() :
      m_r(0),
      m_g(0),
    m_b(0) {
  }
  float m_r;
  float m_g;
  float m_b;
};

// Define some colors
#define GET_COLOR3f(r,g,b,fact)         (float)((fact)*(r))/255.0, \
  (float)((fact)*(g))/255.0,\
  (float)((fact)*(b))/255.0
#define COLOR_DECAY_RATE                0.97
#define PURPLE(fact)                    GET_COLOR3f(171,130,255,fact)
#define YELLOW(fact)                    GET_COLOR3f(255,255,0,fact)
#define ORANGE(fact)                    GET_COLOR3f(255,127,0,fact)
#define GREEN(fact)                     GET_COLOR3f(0,255,0,fact)
#define LIGHT_GREEN(fact)               GET_COLOR3f(124,252,0,fact)
#define PINK(fact)                      GET_COLOR3f(255,20,147,fact)
#define RED(fact)                       GET_COLOR3f(255,0,0,fact)
#define WHITE(fact)                     GET_COLOR3f(255,255,225,fact)
#define BLACK(fact)                     GET_COLOR3f(0,0,0,fact)
#define AQUA(fact)                      GET_COLOR3f(0x00,0xff,0xf6,fact)
#define BLUE(fact)                      GET_COLOR3f(0x00,0x0,0xff,fact)

#define INVALID_X_COORD                (-100000)
/*********************************************************************************
 Functions
**********************************************************************************/
// Unproject point. User needs to make sure the right projection matrix is loaded
// (i.e. ortho or projection) before calling this function.
point getPos(int x, int y);
void switchToOrtho();
void switchToPerspective();
void displayString(float x, float y, char* string);
float randFloat(float a, float b);

#endif //__UI_UTIL__